/**
	This file is part of BUILTU.

    BUILTU is free software: you can redistribute it and/or modify
    it under the terms of the GNU Lesser Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    BUILTU is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser Public License for more details.

    You should have received a copy of the GNU Lesser Public License
    along with BUILTU.  If not, see <http://www.gnu.org/licenses/>.
    
    Copyright (C) 2005-2010 Pasko Boris
 */
package org.builtu.collections.bytearray;

import java.util.List;

import org.builtu.collections.bytearray.FixedByteArray;
import org.builtu.collections.testlist.AbstractTestFixedList;


public class TestFixedByteArray extends AbstractTestFixedList<Byte>
{
  @Override protected Byte makeElement() {
    return (byte)rnd();
  }

  @Override protected List<Byte> makeTestee(final List<Byte> ref) {
    final int prepend = rnd(10), postpend = rnd(10); 
    final byte[] arr = new byte[prepend+ref.size()+postpend];
    for (int i=0; i<ref.size(); i++) arr[prepend+i] = ref.get(i); 
    return new FixedByteArray(arr, prepend, prepend+ref.size());
  }
  
}
