/**
	This file is part of BUILTU.

    BUILTU is free software: you can redistribute it and/or modify
    it under the terms of the GNU Lesser Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    BUILTU is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser Public License for more details.

    You should have received a copy of the GNU Lesser Public License
    along with BUILTU.  If not, see <http://www.gnu.org/licenses/>.
    
    Copyright (C) 2005-2010 Pasko Boris
 */
package org.builtu.collections.graph;

import java.util.Iterator;

import junit.framework.Assert;

import org.builtu.collections.graph.Node;
import org.junit.Test;


public class TestNodeImplToNodeAdapterUnsupportedOperations extends NodeImplToNodeAdapterTestBase {
	
	
	@Test public void add1() {
		try {
			adapter.add(node1);
			Assert.fail();
		} catch (final UnsupportedOperationException e) {}
	}

	@Test public void add2() {
		try {
			adapter.add(0, node1);
			Assert.fail();
		} catch (final UnsupportedOperationException e) {}
	}
	
	@Test public void addAll1() {
		try {
			adapter.addAll(list);
			Assert.fail();
		} catch (final UnsupportedOperationException e) {}
	}
	
	@Test public void addAll2() {
		try {
			adapter.addAll(0, list);
			Assert.fail();
		} catch (final UnsupportedOperationException e) {}
	}
	
	@Test public void clear() {
		try {
			adapter.clear();
			Assert.fail();
		} catch (final UnsupportedOperationException e) {}
	}
	
	@Test public void testIteratorRemove() {
		list.add(node1);
		assertCantRemove(adapter.iterator());
	}

	@Test public void testListIteratorRemove() {
		list.add(node1);
		assertCantRemove(adapter.listIterator());
	}
	
	private static void assertCantRemove(final Iterator<Node<Long>> it) {
		it.next();
		try {
			it.remove();
			Assert.fail();
		} catch (final UnsupportedOperationException e) {}
	}
	
}
