/**
	This file is part of BUILTU.

    BUILTU is free software: you can redistribute it and/or modify
    it under the terms of the GNU Lesser Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    BUILTU is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser Public License for more details.

    You should have received a copy of the GNU Lesser Public License
    along with BUILTU.  If not, see <http://www.gnu.org/licenses/>.
    
    Copyright (C) 2005-2010 Pasko Boris
 */
package org.builtu.config.module.refresh;

import junit.framework.Assert;

import org.builtu.config.module.refresh.SimpleRefreshStrategy;
import org.junit.Before;
import org.junit.Test;



public class TestSimpleRefreshStrategy extends ClockedTestBase {
	
	private SimpleRefreshStrategy strategy;
	
	@Before public void create() {
		strategy = new SimpleRefreshStrategy();
		strategy.setClock(clock);
	}
	
	@Test public void test_every_day() {
		strategy.setRefreshMsecs(SimpleRefreshStrategy.EVERY_DAY);
		strategy.refreshed();
		time += 1000;
		Assert.assertFalse(strategy.hasToBeRefreshed());
		time = SimpleRefreshStrategy.EVERY_DAY;
		Assert.assertTrue(strategy.hasToBeRefreshed());
		time += 1;
		Assert.assertTrue(strategy.hasToBeRefreshed());
		strategy.refreshed();
		Assert.assertFalse(strategy.hasToBeRefreshed());
		time += 1000;
		Assert.assertFalse(strategy.hasToBeRefreshed());
		time += SimpleRefreshStrategy.EVERY_DAY;
		Assert.assertTrue(strategy.hasToBeRefreshed());
	}
	
}
