/**
	This file is part of BUILTU.

    BUILTU is free software: you can redistribute it and/or modify
    it under the terms of the GNU Lesser Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    BUILTU is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser Public License for more details.

    You should have received a copy of the GNU Lesser Public License
    along with BUILTU.  If not, see <http://www.gnu.org/licenses/>.
    
    Copyright (C) 2005-2010 Pasko Boris
 */
package org.builtu.testing.webmock;

import java.io.IOException;

import javax.servlet.http.HttpServletResponse;

public interface Filter {
	/**
	 * Request filter.
	 * @param req
	 * @param mock use this {@link WebMock#handle(Request, HttpServletResponse)} to redirect your requests
	 * @return true if request is handled (will not be processed further), false if this filter cannot fully process the 
	 *         request
	 */
	boolean filter(final Request req, final WebMock mock, final HttpServletResponse response) throws IOException;
}
