/**
	This file is part of BUILTU.

    BUILTU is free software: you can redistribute it and/or modify
    it under the terms of the GNU Lesser Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    BUILTU is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser Public License for more details.

    You should have received a copy of the GNU Lesser Public License
    along with BUILTU.  If not, see <http://www.gnu.org/licenses/>.
    
    Copyright (C) 2005-2010 Pasko Boris
 */
package org.builtu.testing.webmock;

import org.builtu.util.commutil.StringUtil;

public class Result {
	public String contentType, encoding;
	public byte [] data;
	
	public static Result html(final String html) {
		final Result res = new Result();
		res.contentType = "text/html";
		res.encoding = "utf-8";
		res.data = html.getBytes(StringUtil.utf8Charset);
		return res;
	}

	@Override public String toString() {
		return "Result [contentType=" + contentType + ", data=" + dataToString() + ", encoding=" + encoding + "]";
	}

	private String dataToString() {
		if (data.length > 1024) return "[..."+data.length+" bytes...]";
	
		try {
			return new String(data, encoding);
		} catch (final Exception e) {
			return "[error decoding:"+e.getMessage()+"]";
		}
	}
	
	
}
