/**
	This file is part of BUILTU.

    BUILTU is free software: you can redistribute it and/or modify
    it under the terms of the GNU Lesser Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    BUILTU is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser Public License for more details.

    You should have received a copy of the GNU Lesser Public License
    along with BUILTU.  If not, see <http://www.gnu.org/licenses/>.
    
    Copyright (C) 2005-2010 Pasko Boris
 */
package org.builtu.util.commutil;

import org.builtu.testing.BasicTestCase;
import org.builtu.util.commutil.Util;
import org.junit.Test;



public class TestUtilIndexOf extends BasicTestCase {

	@Test public void testEmpty() {
        assertEquals(-1, Util.indexOf(new String[] {}, "aaa"));
    }

    @Test public void testOne() {
        assertEquals(0, Util.indexOf(new String[] { "aaa" }, "aaa"));
        assertEquals(-1, Util.indexOf(new String[] { "aaa" }, "bbb"));
    }

    @Test public void testTwo() {
        final String[] arr = new String[] { "aaa", "bbb" };
        assertEquals(0, Util.indexOf(arr, "aaa"));
        assertEquals(1, Util.indexOf(arr, "bbb"));
        assertEquals(-1, Util.indexOf(arr, "ccc"));
    }

    @Test public void testThree() {
        final String[] arr = new String[] { "aaa", "bbb", "c" };
        assertEquals(0, Util.indexOf(arr, "aaa"));
        assertEquals(1, Util.indexOf(arr, "bbb"));
        assertEquals(2, Util.indexOf(arr, "c"));
        assertEquals(-1, Util.indexOf(arr, "ddd"));
    }

    @Test public void testRandom() {
        final int N = rnd(50);
        final String[] arr = new String[N];
        rndUniqueAlnumStrings(arr);

        for (int i = 0; i < N; i++) {
            assertEquals(i, Util.indexOf(arr, arr[i]));
        }
    }

}
