/**
	This file is part of BUILTU.

    BUILTU is free software: you can redistribute it and/or modify
    it under the terms of the GNU Lesser Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    BUILTU is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser Public License for more details.

    You should have received a copy of the GNU Lesser Public License
    along with BUILTU.  If not, see <http://www.gnu.org/licenses/>.
    
    Copyright (C) 2005-2010 Pasko Boris
 */
package org.builtu.util.commutil;

import java.util.HashMap;
import java.util.Map;

import junit.framework.Assert;

import org.builtu.util.commutil.Util;
import org.junit.Test;


public class TestUtilPut4 {
	//private Map<String, Map<Byte, Map<Integer, Map<Long, Map<Float, Double>>>>> m5;
	//private Map<Byte, Map<Integer, Map<Long, Map<Float, Double>>>> m4;
	//private Map<Integer, Map<Long, Map<Float, Double>>> m3;
	//private Map<Long, Map<Float, Double>> m2;
	//private Map<Float, Double> m1;
	
	@Test public void test0() {
		final Map<Float, Double> m = new HashMap<Float, Double>();
		Assert.assertSame(null, Util.put(m, 1.0f, 1.0));
		Assert.assertEquals(1.0, Util.put(m, 1.0f, 2.0));
		Assert.assertEquals(2.0, m.get(1.0f));
		Assert.assertSame(null, m.get(1.2f));
	}
	
	@Test public void test1() {
		final Map<Long, Map<Float, Double>> m = new HashMap<Long, Map<Float, Double>>();
		Assert.assertSame(null, Util.put(m, 1L, 1.0f, 1.0));
		Assert.assertEquals(1.0, Util.put(m, 1L, 1.0f, 2.0));
		Assert.assertEquals(2.0, m.get(1L).get(1.0f));
		Assert.assertSame(null, m.get(2L));
		Assert.assertSame(null, m.get(1L).get(1.2f));
	}
	
	@Test public void test2() {
		final Map<Integer, Map<Long, Map<Float, Double>>> m = new HashMap<Integer, Map<Long, Map<Float, Double>>>();
		Assert.assertSame(null, Util.put(m, 1, 1L, 1.0f, 1.0));
		Assert.assertEquals(1.0, Util.put(m, 1, 1L, 1.0f, 2.0));
		Assert.assertEquals(2.0, m.get(1).get(1L).get(1.0f));
		Assert.assertSame(null, m.get(2));
		Assert.assertSame(null, m.get(1).get(2L));
		Assert.assertSame(null, m.get(1).get(1L).get(1.2f));
	}
	
	@Test public void test3() {
		final Map<Byte, Map<Integer, Map<Long, Map<Float, Double>>>> m = 
			new HashMap<Byte, Map<Integer, Map<Long, Map<Float, Double>>>>();
		Assert.assertSame(null, Util.put(m, (byte)1, 1, 1L, 1.0f, 1.0));
		Assert.assertEquals(1.0, Util.put(m, (byte)1, 1, 1L, 1.0f, 2.0));
		Assert.assertEquals(2.0, m.get((byte)1).get(1).get(1L).get(1.0f));
		Assert.assertSame(null, m.get((byte)2));
		Assert.assertSame(null, m.get((byte)1).get(2));
		Assert.assertSame(null, m.get((byte)1).get(1).get(2L));
		Assert.assertSame(null, m.get((byte)1).get(1).get(1L).get(1.2f));
	}

	@Test public void test4() {
		final Map<String, Map<Byte, Map<Integer, Map<Long, Map<Float, Double>>>>> m = 
			new HashMap<String, Map<Byte, Map<Integer, Map<Long, Map<Float, Double>>>>>();
		Assert.assertSame(null, Util.put(m, "1", (byte)1, 1, 1L, 1.0f, 1.0));
		Assert.assertEquals(1.0, Util.put(m, "1", (byte)1, 1, 1L, 1.0f, 2.0));
		Assert.assertEquals(2.0, m.get("1").get((byte)1).get(1).get(1L).get(1.0f));
		Assert.assertSame(null, m.get("2"));
		Assert.assertSame(null, m.get("1").get((byte)2));
		Assert.assertSame(null, m.get("1").get((byte)1).get(2));
		Assert.assertSame(null, m.get("1").get((byte)1).get(1).get(2L));
		Assert.assertSame(null, m.get("1").get((byte)1).get(1).get(1L).get(1.2f));
	}
	
}
