/**
	This file is part of BUILTU.

    BUILTU is free software: you can redistribute it and/or modify
    it under the terms of the GNU Lesser Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    BUILTU is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser Public License for more details.

    You should have received a copy of the GNU Lesser Public License
    along with BUILTU.  If not, see <http://www.gnu.org/licenses/>.
    
    Copyright (C) 2005-2010 Pasko Boris
 */
package org.builtu.util.fs;


import java.io.File;
import java.util.Iterator;
import java.util.regex.Pattern;

public class FindIterable implements Iterable<String> {
	
	private final File dir;
	private final Pattern pat;

	public FindIterable(final File dir, final Pattern pat) {
		this.dir = dir;
		this.pat = pat;
	}

	@Override public Iterator<String> iterator() {
		return new FindIterator(dir, pat);
	}

}
